package com.zh.project0512.controller.manage;

import com.zh.project0512.annotation.AdminTokenValid;
import com.zh.project0512.model.dto.RankListDTO;
import com.zh.project0512.service.IRankService;
import com.zh.project0512.service.IVideoService;
import com.zh.project0512.utils.result.Result;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * 排行榜
 */
@Tag(name = "排行榜")
@RestController
@RequestMapping("/manage/rank")
public class RankController {
    @Resource
    IRankService rankService;
    @Autowired
    private IVideoService videoService;

    /**
     * 查询排行榜列表
     *
     * @param rankListDTO 排行列表DTO
     * @return 排行榜列表
     */
    @Operation(summary = "排行列表")
    @PostMapping("/list")
    @AdminTokenValid
    public Result rankList(@Validated @RequestBody RankListDTO rankListDTO) {
        return Result.success(rankService.rankList(rankListDTO), "请求成功");
    }

}
