package com.zh.project0512.controller.wxApp;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zh.project0512.model.AppMessage;
import com.zh.project0512.model.User;
import com.zh.project0512.service.IAppMessageService;
import com.zh.project0512.service.IUserService;
import com.zh.project0512.utils.JwtUtil;
import com.zh.project0512.utils.MybatisPlusUtil;
import com.zh.project0512.utils.result.Result;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 *  app消息
 * </p>
 *
 * @author zh
 * @since 2022-05-26
 */
@RestController
@RequestMapping("/wxApp/userMessage")
@Tag(name = "用户消息")
public class AppMessageController {
    @Autowired
    private IAppMessageService appMessageService;
    @Autowired
    private IUserService userService;
    @PostMapping("/list")
    public Result list( @RequestBody JSONObject obj, @RequestHeader(value = "token") @Parameter(name = "登录token") String token){
        String openid = new JwtUtil().parseOpenid(token);
        User user = userService.selByOpenid(openid);
        QueryWrapper<AppMessage> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("receiverId",user.getId());
        queryWrapper.orderByDesc("createDate");
        return Result.success( appMessageService.page(MybatisPlusUtil.SetPage(obj),queryWrapper),"请求成功");
    }

}
