package com.zh.project0512.mapper;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.zh.project0512.model.Admin;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.project0512.model.User;
import com.zh.project0512.model.Video;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2022-06-10
 */
public interface AdminMapper extends BaseMapper<Admin> {
    @Select("SELECT  \n" +
        "(SELECT COUNT(1) from task) as taskNum,\n" +
        "(SELECT COUNT(1) from reference) as referenceNum,\n" +
        "(SELECT COUNT(1) from customerActionNote) as customerActionNoteNum,\n" +
        "sum(IFNULL(v.playNum,0)) as playNumSum, \n" +
        "sum(IFNULL(v.commendNum,0)) as commendNumSum, \n" +
        "sum(IFNULL(v.collectionNum,0)) as collectionNumSum, \n" +
        "sum(IFNULL(v.commentNum,0)) as commentNumSum, \n" +
        "sum(IFNULL(v.reSendNum,0)) as reSendNumSum, \n" +
        "sum(IFNULL(v.recommendNum,0)) as recommendNumSum\n" +
        "      from video as v ")
    JSONObject statistics1();

    @Select("SELECT date_format(creatAt, '%Y-%m-%d') as dat" +
        ",sum(IFNULL(playNum,0)) as playNumSum " +
        ",sum(IFNULL(commendNum,0)) as commendNumSum " +
        ",sum(IFNULL(collectionNum,0)) as collectionNumSum " +
        ",sum(IFNULL(commentNum,0)) as commentNumSum " +
        ",sum(IFNULL(reSendNum,0)) as reSendNumSum " +
        ",sum(IFNULL(recommendNum,0)) as recommendNumSum " +
        "from video \n" +
        "where dat" +
        "<if test='ew != null'>" +
        "<if test='ew.nonEmptyOfWhere'>" +
        "AND " +
        "</if> " +
        "${ew.SqlSegment}" +
        "</if> " +
        "GROUP BY dat ORDER BY dat ")
    List<JSONObject> statistics2(@Param("ew") Wrapper<Video> queryWrapper);
}
