package com.zh.project0512.serviceImpl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zh.project0512.model.Reference;
import com.zh.project0512.model.Task;
import com.zh.project0512.mapper.TaskMapper;
import com.zh.project0512.service.ITaskService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.ibatis.annotations.Param;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zh
 * @since 2022-05-21
 */
@Service
public class TaskServiceImpl extends ServiceImpl<TaskMapper, Task> implements ITaskService {
    @Autowired
    private TaskMapper taskMapper;

    public void add(Task task) {
        taskMapper.add(task);
    }
    public IPage<Integer> idList(IPage iPage,String openid, List<Integer> tagIdList, List<Integer> brandIdList, @Param("ew") Wrapper<Reference> queryWrapper){
        return taskMapper.idList(iPage,openid,tagIdList,brandIdList,queryWrapper);
    }
    public List<Map> list(String openid,List<Integer> list, List<Integer> tagIdList, List<Integer> brandIdList, @Param("ew") Wrapper<Reference> queryWrapper){
        return taskMapper.list(openid,list,tagIdList,brandIdList,queryWrapper);
    }
    public Task detailById(String openid,int id){
       return taskMapper.detailById(openid,id);
    }
    public JSONObject taskEffect(@Param("ew") Wrapper<Task> queryWrapper){
        return taskMapper.taskEffect(queryWrapper);
    }
    public List<Map> taskEffectData(@Param("ew") Wrapper<Task> queryWrapper){
        return taskMapper.taskEffectData(queryWrapper);
    }
    public List<Map> taskDepartment(int taskId){
        return taskMapper.taskDepartment(taskId);
    }
}
